function [lam1,lam2,lam3,lam4,lam5,lam6,lam7,lam8,lam9,lam10] = bary10(V1,V2,V3,V4,V5,V6,V7,V8,V9,V10,X,Y);
%        [lam1,lam2,lam3,lam4,lam5,lam6,lam7,lam8,lam9,lam10] = bary9(V1,V2,V3,V4,V5,V6,V7,V8,V9,V10,X,Y);
% This function returns the barycentric coordinates with respect to the 
% polygon [V1,V2,V3,V4,V5,V6,V7,V8,V9] of the points (X,Y);
% Author: Ming-Jun Lai
% e-mail: mjlai@math.uga.edu
% Created: Feb. 2015, using Matlab R2014b
% Copyright 2015.
V=[X Y];
lam1=triarea(V1,V2,V); lam2=triarea(V2,V3,V); lam3=triarea(V3,V4,V); lam4=triarea(V4,V5,V);
lam5=triarea(V5,V6,V);lam6=triarea(V6,V7,V); lam7=triarea(V7,V8,V); lam8=triarea(V8,V9,V);
lam9=triarea(V9,V10,V); lam10=triarea(V10,V1,V);

