function [lam1,lam2,lam3,lam4,lam5] = baryP(V1,V2,V3,V4,V5,X,Y);
%        [lam1,lam2,lam3,lam4,lam5] = baryP(V1,V2,V3,V4,V5,X,Y);
% This function returns the barycentric coordinates with respect to the 
% pentagon [V1,V2,V3,V4,V5] of the points (X,Y);
% Author: Ming-Jun Lai
% e-mail: mjlai@math.uga.edu
% Created: Dec. 2014, using Matlab R2014b
% Copyright 2014.
V=[X Y];
lam1=triarea(V1,V2,V); lam2=triarea(V2,V3,V); lam3=triarea(V3,V4,V); lam4=triarea(V4,V5,V);
lam5=triarea(V5,V1,V);

