function [nV,nP]=refine10(V,P);
%V is of size 9x2. P is of 1x8.
% e-mail: mjlai@math.uga.edu
% Created: Feb. 2015, using Matlab R2014b
% Copyright 2015.
[l,m]=size(P);
nV=V;  nP={}; 
for i=1:m
n=size(nV,1);
p=P{i};
u1=V(p(1),:); u2=V(p(2),:); u3=V(p(3),:); u8=V(p(8),:); u10=V(p(10),:);
u4=V(p(4),:); u5=V(p(5),:); u6=V(p(6),:); u7=V(p(7),:); u9=V(p(9),:);
v1=(u1+u2+u3+u4+u5+u6+u7+u8+u9+u10)/10;
v2=(u1+u2)/2;
v3=(u2+u3)/2;
v4=(u3+u4)/2;
v5=(u4+u5)/2; 
v6=(u5+u6)/2;
v7=(u7+u6)/2;
v8=(u8+u7)/2;
v9=(u9+u8)/2;
v10=(u10+u9)/2;
v11=(u1+u10)/2;
v12=(v1+v2)/2;
v13=(v1+v3)/2;
v14=(v1+v4)/2;
v15=(v1+v5)/2;
v16=(v1+v6)/2;
v17=(v1+v7)/2;
v18=(v1+v8)/2;
v19=(v1+v9)/2;
v20=(v1+v10)/2;
v21=(v1+v11)/2;
J=find(v2(1,1)==nV(:,1) & v2(1,2)==nV(:,2));
if isempty(J)
%nV=[nV;v1;v2;v3;v4;v5;v6;v7;v8;v9;v10;v11]; 
nV=[nV;v2]; n2=n+1; n=n2;
else 
    n2=J(1);
end
J=find(v3(1,1)==nV(:,1) & v3(1,2)==nV(:,2));
if isempty(J)
%nV=[nV;v1;v2;v3;v4;v5;v6;v7;v8;v9;v10;v11]; 
nV=[nV;v3]; n3=n+1; n=n3;
else 
    n3=J(1);
end
J=find(v4(1,1)==nV(:,1) & v4(1,2)==nV(:,2));
if isempty(J)
%nV=[nV;v1;v2;v3;v4;v5;v6;v7;v8;v9;v10;v11]; 
nV=[nV;v4]; n4=n+1; n=n4;
else 
    n4=J(1);
end
J=find(v5(1,1)==nV(:,1) & v5(1,2)==nV(:,2));
if isempty(J)
%nV=[nV;v1;v2;v3;v4;v5;v6;v7;v8;v9;v10;v11]; 
nV=[nV;v5]; n5=n+1; n=n5;
else 
    n5=J(1);
end
J=find(v6(1,1)==nV(:,1) & v6(1,2)==nV(:,2));
if isempty(J)
%nV=[nV;v1;v2;v3;v4;v5;v6;v7;v8;v9;v10;v11]; 
nV=[nV;v6]; n6=n+1; n=n6;
else 
    n6=J(1);
end
J=find(v7(1,1)==nV(:,1) & v7(1,2)==nV(:,2));
if isempty(J)
%nV=[nV;v1;v2;v3;v4;v5;v6;v7;v8;v9;v10;v11]; 
nV=[nV;v7]; n7=n+1; n=n7;
else 
    n7=J(1);
end
J=find(v8(1,1)==nV(:,1) & v8(1,2)==nV(:,2));
if isempty(J)
%nV=[nV;v1;v2;v3;v4;v5;v6;v7;v8;v9;v10;v11]; 
nV=[nV;v8]; n8=n+1; n=n8;
else 
    n8=J(1);
end
J=find(v9(1,1)==nV(:,1) & v9(1,2)==nV(:,2));
if isempty(J)
%nV=[nV;v1;v2;v3;v4;v5;v6;v7;v8;v9;v10;v11]; 
nV=[nV;v9]; n9=n+1; n=n9;
else 
    n9=J(1);
end
J=find(v10(1,1)==nV(:,1) & v10(1,2)==nV(:,2));
if isempty(J)
%nV=[nV;v1;v2;v3;v4;v5;v6;v7;v8;v9;v10;v11]; 
nV=[nV;v10]; n10=n+1; n=n10;
else 
    n10=J(1);
end
J=find(v11(1,1)==nV(:,1) & v11(1,2)==nV(:,2));
if isempty(J)
%nV=[nV;v1;v2;v3;v4;v5;v6;v7;v8;v9;v10;v11]; 
nV=[nV;v11]; n11=n+1; n=n11;
else 
    n11=J(1);
end
J=find(v12(1,1)==nV(:,1) & v12(1,2)==nV(:,2));
if isempty(J)
nV=[nV;v12]; n12=n+1; n=n12;
else 
    n12=J(1);
end
J=find(v13(1,1)==nV(:,1) & v13(1,2)==nV(:,2));
if isempty(J)
nV=[nV;v13]; n13=n+1; n=n13;
else 
    n13=J(1);
end
J=find(v14(1,1)==nV(:,1) & v14(1,2)==nV(:,2));
if isempty(J)
nV=[nV;v14]; n14=n+1; n=n14;
else 
    n14=J(1);
end
J=find(v15(1,1)==nV(:,1) & v15(1,2)==nV(:,2));
if isempty(J)
nV=[nV;v15]; n15=n+1; n=n15;
else 
    n15=J(1);
end
J=find(v16(1,1)==nV(:,1) & v16(1,2)==nV(:,2));
if isempty(J)
nV=[nV;v16]; n16=n+1; n=n16;
else 
    n16=J(1);
end
J=find(v17(1,1)==nV(:,1) & v17(1,2)==nV(:,2));
if isempty(J)
nV=[nV;v17]; n17=n+1; n=n17;
else 
    n17=J(1);
end
J=find(v18(1,1)==nV(:,1) & v18(1,2)==nV(:,2));
if isempty(J)
nV=[nV;v18]; n18=n+1; n=n18;
else 
    n18=J(1);
end
J=find(v19(1,1)==nV(:,1) & v19(1,2)==nV(:,2));
if isempty(J)
nV=[nV;v19]; n19=n+1; n=n19;
else 
    n19=J(1);
end
J=find(v20(1,1)==nV(:,1) & v20(1,2)==nV(:,2));
if isempty(J)
nV=[nV;v20]; n20=n+1; n=n20;
else 
    n20=J(1);
end
J=find(v21(1,1)==nV(:,1) & v21(1,2)==nV(:,2));
if isempty(J)
nV=[nV;v21]; n21=n+1; n=n21;
else 
    n21=J(1);
end
P1=[p(1),n2,n12,n21,n11]; 
P2=[p(2),n3,n13,n12,n2];
P3=[p(3),n4,n14,n13,n3];
P4=[p(4),n5,n15,n14,n4];
P5=[p(5),n6,n16,n15,n5];
P6=[p(6),n7,n17,n16,n6];
P7=[p(7),n8,n18,n17,n7];
P8=[p(8),n9,n19,n18,n8];
P9=[p(9),n10,n20,n19,n9];
P10=[p(10),n11,n21,n20,n10];
P11=[n12,n13,n14,n15,n16,n17,n18,n19,n20,n21];
%V=[P1 P2 P3 P4 P5 P6]; 
nP2={P1,P2,P3,P4,P5,P6,P7,P8,P9,P10,P11};
if isempty(nP)
    nP=nP2;
else
    nP={nP{:},nP2{:}};
end
end
%[size(nV), size(nP)]